unit TweedeGraadsFunctie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Panel3: TPanel;
    Panel4: TPanel;
    Uit_f: TEdit;
    Uit_g: TEdit;
    Uit_a: TEdit;
    Uit_b: TEdit;
    Uit_c: TEdit;
    Uit_d: TEdit;
    Uit_1: TEdit;
    Uit_2: TEdit;
    Uit_3: TEdit;
    Uit_4: TEdit;
    Uit_5: TEdit;
    Uit_6: TEdit;
    Uit_7: TEdit;
    Uit_8: TEdit;
    Uit_9: TEdit;
    Uit_p: TEdit;
    KnopStopGenereren: TButton;
    KnopPlotRaaklijnen: TButton;
    KnopNulpuntenNumeriek: TButton;
    KnopExtremeWaardeParaboolABCformule: TButton;
    KnopNulpuntenParaboolABCformule: TButton;
    KnopReset: TButton;
    KnopOppervlaktebepaling: TButton;
    KnopExtremeWaarden: TButton;
    KnopFunctiegenerator: TButton;
    ScrollBarDomein: TScrollBar;
    GroupBox1: TGroupBox;
    ScrollBarc: TScrollBar;
    ScrollBarb: TScrollBar;
    ScrollBara: TScrollBar;
    ScrollBard: TScrollBar;
    ScrollBarOppBegrenzing: TScrollBar;
    GroupBox7: TGroupBox;
    ScrollBarTransparantie: TScrollBar;
    GroupBox6: TGroupBox;
    CheckBoxP: TCheckBox;
    CheckBoxF: TCheckBox;
    CheckBoxG: TCheckBox;
    RadioButtonX1: TRadioButton;
    RadioButtonX2: TRadioButton;
    ScrollBarRaaklijn: TScrollBar;
    Plotgebied: TImage;
    KnopPlotP: TButton;
    KnopPlotF: TButton;
    KnopPlotG: TButton;
    GroupBox8: TGroupBox;
    CheckBoxFixTangents: TCheckBox;
    CheckBoxPlotTangentsofF: TCheckBox;
    CheckBoxPlotTangentsOfP: TCheckBox;
    GroupBox9: TGroupBox;
    ScrollBarDxTangents: TScrollBar;
    Panel1: TPanel;
    procedure FormActivate(Sender: TObject);
    procedure KnopClearScreenClick(Sender: TObject);
    procedure ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopResetClick(Sender: TObject);
    procedure KnopPlotFClick(Sender: TObject);
    procedure KnopNulpuntenNumeriekClick(Sender: TObject);
    procedure KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
    procedure KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
    procedure ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure KnopPlotGClick(Sender: TObject);
    procedure KnopFunctiegeneratorClick(Sender: TObject);
    procedure KnopStopGenererenClick(Sender: TObject);
    procedure KnopPlotRaaklijnenClick(Sender: TObject);
    procedure KnopExtremeWaardenClick(Sender: TObject);
    procedure KnopPlotPClick(Sender: TObject);
    procedure KnopOppervlaktebepalingClick(Sender: TObject);
    procedure ScrollBarOppBegrenzingScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure ScrollBarDomeinScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure KnopRaaklijnenPClick(Sender: TObject);
    procedure ScrollBarTransparantieScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure CheckBoxPClick(Sender: TObject);
    procedure CheckBoxFClick(Sender: TObject);
    procedure CheckBoxGClick(Sender: TObject);
    procedure RadioButtonX1Click(Sender: TObject);
    procedure RadioButtonX2Click(Sender: TObject);
    procedure ScrollBarRaaklijnScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure CheckBoxFixTangentsClick(Sender: TObject);
    procedure CheckBoxPlotTangentsofFClick(Sender: TObject);
    procedure CheckBoxPlotTangentsOfPClick(Sender: TObject);
    procedure ScrollBarDxTangentsScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);

  private
    { Private declarations }
  public
    { Public declarations }
       procedure ToonFunctievoorschriftBouwschema;
       procedure ToonFunctievoorschrift;
       procedure PlotAssenstelsel;
       procedure FunctiePlotten(k:char;start,stop:real;Kleur:TColor);
       procedure ClearScreen;
       procedure EditAll;
       procedure wisEditAll;
       procedure ExtremeWaardeParaboolABCformule;
       procedure NulpuntenParaboolABCformule;
       procedure ExtremeWaarden;
       procedure RaaklijnPlotten(k:char;i:byte);
       procedure RaaklijnPlottenSerie(k:char;i:byte);
       procedure OppervlakVullen(i:integer);
       function conversiex(x:real):integer;
       function conversiey(y:real):integer;
       function p(x:real):real;
       function f(x:real):real;
       function g(x:real):real;
       function r(x:real):real;
       function conI (i:integer): string;
       function conR (r:real): string;
  end;

const interval=0.001; pixx=1170; pixy=672;  {696}
      x0=(pixx div 2); y0=(pixy div 2);
      clG=clRed; clF=clPurple; clP=clOlive; clScreen=clWhite;

var
  Form1                                           : TForm1;
  stoppen                                         : boolean;
  gereset                                         : boolean;
  Fvastgezet                                      : boolean;
  Gvastgezet                                      : boolean;
  Pvastgezet                                      : boolean;
  xoinstellen,xbinstellen                         : boolean;
  PlotTangentsOfF,PlotTangentsOfP                 : boolean;
  FixTangents                                     : boolean;
  dint,dmin,dmax                                  : integer;
  a,b,c,d,x,y,x1,x2,dx,xo,xb,opp,xmax,ymax,dis,aa,bb : real;

implementation

{$R *.dfm}

function Tform1.p(x:real):real;
begin
   p:=(1/4)*d*x*x*x*x+(1/3)*a*x*x*x+(1/2)*b*x*x+c*x;
end; {De primitieve van f voor oppervlakteberekening}

function Tform1.f(x:real):real;
begin
   f:=(d*x*x*x)+(a*x*x)+(b*x)+c;
end; {De te onderzoeken functie f}

function Tform1.g(x:real):real;
begin
   g:=3*d*x*x+2*a*x+b;
end; {De afgeleide van f voor de richtingscoefficienten van de raaklijnen}

function Tform1.r(x:real):real;
begin
   r:=(aa*x)+bb;
end; {Functie voor de raaklijnen}

Procedure TForm1.ToonFunctievoorschriftBouwschema;
begin
  uit_p.text:='y ='#188+'dx^4'+'+1/3ax'+#179+'+'#189+'bx'+#178+'+cx';
  uit_f.text:='y =dx'+#179+'+ax'+#178+'+bx'+'+c';
  uit_g.text:='y =3dx'+#178+'+2ax'+'+b';
end;

Procedure TForm1.ToonFunctievoorschrift;
var t4,t1,t2,t3 : string[4];
    S4,S1,S2,S3 : string[20];
    g4,g1,g2,g3 : string[5];
    e4,e1,e2,e3 : string[4];
begin
   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0then t1:='-';
   if a=0 then t1:='+';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:='+';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:='+';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(0.25*d);
   if d<0 then g4:=conR(-0.25*d);
   if a>0 then g1:=conR(0.33*a);
   if a<0 then g1:=conR(-0.33*a);
   if b>0 then g2:=conR(0.5*b);
   if b<0 then g2:=conR(-0.5*b);
   if c>0 then g3:=conR(c);
   if c<0 then g3:=conR(-c);

   if d=0 then e4:=' ' else e4:=' x^4';
   if a=0 then e1:=' ' else e1:=' x'+#179;
   if b=0 then e2:=' ' else e2:=' x'+#178;
   if c=0 then e3:=' ' else e3:=' x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3+e3;

   Uit_p.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:=' ';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if c<0 then t3:='-';
   if c=0 then t3:=' ';
   if c>0 then t3:='+';

   if d>0 then g4:=conR(d)else g4:=conR(-d);
   if a>0 then g1:=conR(a)else g1:=conR(-a);
   if b>0 then g2:=conR(b)else g2:=conR(-b);
   if c>0 then g3:=conR(c)else g3:=conR(-c);

   if d=0 then e4:=' ' else e4:='x'+#179;
   if a=0 then e1:=' ' else e1:='x'+#178;
   if b=0 then e2:=' ' else e2:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2+e2;
   S3:=t3+g3;

   Uit_f.Text:='y='+S4+S1+S2+S3;

   if d<0 then t4:='-';
   if d=0 then t4:=' ';
   if d>0 then t4:=' ';

   if a<0 then t1:='-';
   if a=0 then t1:=' ';
   if a>0 then t1:='+';

   if b<0 then t2:='-';
   if b=0 then t2:=' ';
   if b>0 then t2:='+';

   if d>0 then g4:=conR(3*d) else g4:=conR(-3*d);
   if a>0 then g1:=conR(2*a) else g1:=conR(-2*a);
   if b>0 then g2:=conR(b) else g2:=conR(-b);

   if d=0 then e4:=' ' else e4:='x'+#178;
   if a=0 then e1:=' ' else e1:='x';

   S4:=t4+g4+e4;
   S1:=t1+g1+e1;
   S2:=t2+g2;

   Uit_g.Text:='y='+S4+S1+S2;
end;

procedure TForm1.EditAll;
begin
  Uit_a.text:='a = '+conR(a); Uit_b.text:='b = '+conR(b);
  Uit_c.text:='c = '+conR(c); Uit_d.text:='d = '+conR(d);
  Uit_6.text:=conR(xo); Uit_7.text:=conR(xb);
end;

procedure TForm1.WisEditAll;
begin
 Uit_1.Text:=' '; Uit_2.Text:=' '; Uit_3.Text:=' ';
 Uit_4.Text:=' '; Uit_5.Text:=' '; Uit_6.Text:=' ';
 Uit_7.Text:=' '; Uit_8.Text:=' '; Uit_9.Text:=' ';
 Uit_9.Text:=' ';
end;

function TForm1.conI (i:integer): string;
begin
  conI:=IntToStr(i);
end;

function TForm1.conR (r:real): string;
begin
  conR:=FloatToStrF(r,ffFixed,1,2);
end;

procedure TForm1.NulpuntenParaboolABCformule;
begin
   if a<>0 then Dis:=((b*b)-(4*a*c));
   if ((Dis>=0) and (a<>0) and (d=0)) then
     begin
      x1:=(-b-sqrt(Dis))/(2*a);
      x2:=(-b+sqrt(Dis))/(2*a);
      Uit_1.Text:=conR(x1)+' '+conR(x2);
      Plotgebied.Canvas.TextOut(conversiex(x1),conversiey(0),conR(x1));
      Plotgebied.Canvas.TextOut(conversiex(x2),conversiey(0),conR(x2));
     end;
  if dis<0 then  Uit_1.Text:='D < 0';
  if a=0   then  Uit_1.Text:='a = 0';
  if d<>0  then Uit_1.Text:='D <> 0';
end;

procedure TForm1.RaaklijnPlotten(k:char;i:byte);
var kleur:TColor;
begin
 if k='f' then begin aa:=g(x); bb:=f(x)-(x*g(x)); kleur:=clF; end;
 if k='p' then begin aa:=f(x); bb:=p(x)-(x*f(x)); kleur:=clP; end;
 if i=0 then kleur:=clScreen;
 {if k='f' then FunctiePlotten('f',x-0.5,x+0.5,clF);
 if k='p' then FunctiePlotten('p',x-0.5,x+0.5,clP);}
 if ((aa>-0.5) and (aa<0.5)) then PlotAssenstelsel;
 Plotgebied.Canvas.MoveTo(conversiex(dmin),conversiey(r(dmin)));
 Plotgebied.Canvas.Pen.Color:=Kleur;
 Plotgebied.Canvas.LineTo(conversiex(dmax),conversiey(r(dmax)));
 if k='f' then Uit_9.Text:='y = '+conR(aa)+'x '+conR(bb);
 if k='p' then Uit_9.Text:='y = '+conR(aa)+'x '+conR(bb);
end;

procedure TForm1.RaaklijnPlottenSerie(k:char;i:byte);
begin
 x:=dmin;
 while ((x<=dmax) and not (stoppen)) do
  begin
     if i=0 then RaaklijnPlotten(k,0);
     x:=x+dx;
     RaaklijnPlotten(k,1);
     application.processmessages;
  end;
end;

procedure TForm1.ScrollBarDxTangentsScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  dx:=0.1-(0.001*ScrollPos);
end;

procedure TForm1.PlotAssenstelsel;
begin
  Plotgebied.Canvas.Pen.Color:=clBlack;
  Plotgebied.Canvas.MoveTo(0,(pixy div 2));
  Plotgebied.Canvas.LineTo(pixx,pixy div 2);
  Plotgebied.Canvas.MoveTo(pixx div 2,0);
  Plotgebied.Canvas.LineTo(pixx div 2,pixy);
  Plotgebied.Canvas.MoveTo(pixx-1,0);
  Plotgebied.Canvas.LineTo(pixx-1,pixx+pixy);
  Plotgebied.Canvas.MoveTo(0,pixy-1);
  Plotgebied.Canvas.LineTo(pixx,pixy-1);
  Plotgebied.Canvas.TextOut(pixx-30,(pixy div 2)+3,'x ['+conI(dmax)+']');
  Plotgebied.Canvas.TextOut((pixx div 2)+5,5,'y ['+conI(dmax)+']');
end;

procedure TForm1.ClearScreen;
begin
  Plotgebied.Canvas.Brush.Color:=clWhite;
  Plotgebied.Canvas.Rectangle(0,0,pixx+9,pixy+9);
  Plotgebied.Canvas.Refresh; PlotAssenstelsel;
end;

function TForm1.conversiex(x:real):integer;
var Sx:real;
begin
 Sx:=pixx div (dmax-dmin);
 conversiex:=x0+ROUND(x*Sx);
end;

function TForm1.conversiey(y:real):integer;
var Sy:real;
begin
 Sy:=(pixy div 2) div dmax;
 conversiey:=y0-ROUND(y*Sy);
end;

procedure TForm1.FunctiePlotten(k:char;start,stop:real;Kleur:TColor);
var x_temp:real;
begin
  x_temp:=start; Plotgebied.Canvas.Pen.Color:=Kleur;
  if k='p' then begin Plotgebied.Canvas.MoveTo(conversiex(x_temp),conversiey(p(x_temp))); end;
  if k='f' then begin Plotgebied.Canvas.MoveTo(conversiex(x_temp),conversiey(f(x_temp))); end;
  if k='g' then begin Plotgebied.Canvas.MoveTo(conversiex(x_temp),conversiey(g(x_temp))); end;
  if ((d<>0) or (a<>0)) then
   if k='r' then begin Plotgebied.Canvas.MoveTo(conversiex(x_temp),conversiey(r(x_temp))); end;
  While ((x_temp<=stop) and (not stoppen)) do
    begin
     if k='p' then begin Plotgebied.Canvas.LineTo(conversiex(x_temp),conversiey(p(x_temp))); end;
     if k='f' then begin Plotgebied.Canvas.LineTo(conversiex(x_temp),conversiey(f(x_temp))); end;
     if k='g' then begin Plotgebied.Canvas.LineTo(conversiex(x_temp),conversiey(g(x_temp))); end;
     if ((d<>0) or (a<>0)) then
     if k='r' then begin Plotgebied.Canvas.LineTo(conversiex(x_temp),conversiey(r(x_temp))); end;
     x_temp:=x_temp+interval;
    end;
  ToonFunctievoorschrift;
end;

procedure TForm1.OppervlakVullen(i:integer);
const dx=0.01;
begin
  x:=xo;
  if i=1 then Plotgebied.Canvas.Pen.Color:=clPurple;
  if i=0 then Plotgebied.Canvas.Pen.Color:=clWhite;
  While ((x<=xb) and (not stoppen)) do
    begin
     y:=f(x);
     Plotgebied.Canvas.MoveTo(conversiex(x),conversiey(0));
     Plotgebied.Canvas.LineTo(conversiex(x),conversiey(y));
     sleep(0);
     x:=x+dx;
     Uit_8.Text:=conR(p(x)-p(xo));
     application.processmessages;
    end;
end;

procedure TForm1.KnopNulpuntenParaboolABCformuleClick(Sender: TObject);
begin
  NulpuntenParaboolABCformule;
end;

procedure TForm1.ExtremeWaardeParaboolABCformule;
begin
  if ((a<>0) and (d=0)) then
    begin
     ymax:=f(-b/(2*a));
     Uit_2.Text:=conR(-b/(2*a))+'  '+conR(ymax);
     Plotgebied.Canvas.TextOut(conversiex(-b/(2*a)),conversiey(ymax),conR(-b/(2*a))+' '+(conR(ymax)));
    end else
  if a=0 then Uit_2.Text:='a = 0';
  if d<>0 then Uit_2.Text:='D <> 0';
end;

procedure TForm1.KnopExtremeWaardeParaboolABCformuleClick(Sender: TObject);
begin
 ExtremeWaardeParaboolABCformule;
end;

procedure TForm1.KnopNulpuntenNumeriekClick(Sender: TObject);
const                                       max=100;
type             NulpuntenGeheugen=array[1..max] of real;
var N          : NulpuntenGeheugen;
    Ns         : string;
    x,y,dx,m   : real;
    i          : integer;
begin
 for i:=1 to max do N[i]:=-111;
 i:=1; dx:=0.01; m:=5*dx; x:=dmin; Ns:=' ';
 while x<=dmax do
  begin
    y:=f(x);
    if ((y>-m) and (y<m)) then
      begin
       N[i]:=x; inc(i); Ns:=Ns+conR(x)+' ';
      end;
    x:=x+dx;
  end;
  Uit_4.text:=' '+conI(i-1); Uit_5.text:=Ns;
end;

procedure TForm1.ScrollBarRaaklijnScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
var xPos : real;
begin
  if PlotTangentsOfF then
   if not FixTangents then RaaklijnPlotten('f',0);
  if PlotTangentsOfP then
   if not FixTangents then RaaklijnPlotten('p',0);
  x:=ScrollPos/(2*dmax);
  if PlotTangentsOfF then RaaklijnPlotten('f',1);
  if PlotTangentsOfP then RaaklijnPlotten('p',1);
end;

procedure TForm1.KnopPlotRaaklijnenClick(Sender: TObject);
begin
  if PlotTangentsOfF then
   begin
    if FixTangents then RaaklijnPlottenSerie('f',1);
    if not FixTangents then RaaklijnPlottenSerie('f',0);
   end;
  if PlotTangentsOfP then
   begin
    if FixTangents then RaaklijnPlottenSerie('p',1);
    if not FixTangents then RaaklijnPlottenSerie('p',0);
   end;
end;

procedure TForm1.CheckBoxPlotTangentsofFClick(Sender: TObject);
begin
 PlotTangentsOfF:= not PlotTangentsOfF;
end;

procedure TForm1.CheckBoxPlotTangentsOfPClick(Sender: TObject);
begin
 PlotTangentsOfP:= not PlotTangentsOfP;
end;

procedure TForm1.CheckBoxFixTangentsClick(Sender: TObject);
begin
FixTangents:= not FixTangents;
end;

procedure TForm1.KnopRaaklijnenPClick(Sender: TObject);
begin
  RaaklijnPlottenSerie('p',0);
end;

procedure TForm1.KnopFunctiegeneratorClick(Sender: TObject);
const max=4;
begin
 stoppen:=false;
 while not stoppen do
  begin
   Randomize;
   d:=Random(max)- (max div 2);
   a:=Random(max)- (max div 2);
   b:=Random(max)- (max div 2);
   c:=Random(max)- (max div 2);
   EditAll; ClearScreen;
   FunctiePlotten('f',dmin,dmax,clF);
   FunctiePlotten('g',dmin,dmax,clG);
   FunctiePlotten('p',dmin,dmax,clP);
   OppervlakVullen(1);
   OppervlakVullen(0);
   PlotAssenstelsel;
   if ((a<>0) or (d<>0)) then
    begin
     if PlotTangentsOfF then
      if not FixTangents then RaaklijnPlottenSerie('f',0) else
       if FixTangents then RaaklijnPlottenSerie('f',1);
     if PlotTangentsOfP then
      begin
       ClearScreen;
       FunctiePlotten('f',dmin,dmax,clF);
       FunctiePlotten('g',dmin,dmax,clG);
       FunctiePlotten('p',dmin,dmax,clP);
       if not FixTangents then RaaklijnPlottenSerie('p',0)else
        if FixTangents then RaaklijnPlottenSerie('p',1);
      end;
    end;
   sleep(350);
   wisEditAll;
   PlotAssenstelsel;
  end;
 stoppen:=false;
end;

procedure TForm1.ExtremeWaarden;
var dis,aa,bb,cc,x1,x2,y1,y2: real;
begin
   if d<>0 then
    begin
      aa:=3*d; bb:=2*a; cc:=b;
      if aa<>0 then dis:=((bb*bb)-(4*aa*cc));
      if ((dis>=0) and (aa<>0)) then
       begin
        x1:=(-bb-sqrt(dis))/(2*aa); y1:=f(x1);
        x2:=(-bb+sqrt(dis))/(2*aa); y2:=f(x2);
       end;
      if dis>=0 then
       begin
        Uit_3.Text:=conR(x1)+' '+conR(y1)+'   '+conR(x2)+' '+conR(y2);
        Plotgebied.Canvas.TextOut(conversiex(x1),conversiey(y1),conR(x1)+' '+conR(y1));
        Plotgebied.Canvas.TextOut(conversiex(x2),conversiey(y2),conR(x2)+' '+conR(y2));
       end;
       if dis<0 then Uit_3.Text:='... geen gevonden ..';
    end;

   if ((d=0) and (a<>0)) then
    begin
     aa:=a; bb:=b;
     x1:=-bb/(2*aa); y1:=f(x1);
     Uit_3.Text:=conR(x1)+' '+conR(y1);
    end;
end;

procedure TForm1.KnopExtremeWaardenClick(Sender: TObject);
begin
 ExtremeWaarden;
end;

procedure TForm1.KnopStopGenererenClick(Sender: TObject);
begin
  stoppen:=not stoppen;
end;

procedure TForm1.KnopPlotPClick(Sender: TObject);
begin
  stoppen:=false;
  EditAll; FunctiePlotten('p',dmin,dmax,clP);
end;

procedure TForm1.KnopPlotFClick(Sender: TObject);
begin
  stoppen:=false;
  EditAll;
  FunctiePlotten('f',dmin,dmax,clF);
end;

procedure TForm1.KnopPlotGClick(Sender: TObject);
begin
  stoppen:=false;
  EditAll;
  FunctiePlotten('g',dmin,dmax,clG);
end;

procedure TForm1.KnopClearScreenClick(Sender: TObject);
begin
  ClearScreen; stoppen:=true;
end;

procedure TForm1.KnopResetClick(Sender: TObject);
begin
  d:=0; a:=0; b:=0; c:=0;
  wisEditAll; gereset:=true;
  ToonFunctievoorschriftBouwschema;
end;

procedure TForm1.CheckBoxPClick(Sender: TObject);
begin
 Pvastgezet:=not Pvastgezet; EditAll;
end;

procedure TForm1.CheckBoxFClick(Sender: TObject);
begin
 Fvastgezet:=not Fvastgezet; EditAll;
end;

procedure TForm1.CheckBoxGClick(Sender: TObject);
begin
 Gvastgezet:=not Gvastgezet; EditAll;
end;

procedure TForm1.KnopOppervlaktebepalingClick(Sender: TObject);
begin
 OppervlakVullen(1);
end;

procedure TForm1.ScrollBarOppBegrenzingScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
 if xoinstellen then
  begin
   xo:=ScrollPos; xo:=xo/10; uit_6.text:=conR(xo);
  end;
 if xbinstellen then
  begin
   xb:=ScrollPos; xb:=xb/10; uit_7.text:=conR(xb);
  end;
end;

procedure TForm1.RadioButtonX1Click(Sender: TObject);
begin
 xoinstellen:=true; xbinstellen:=false;
end;

procedure TForm1.RadioButtonX2Click(Sender: TObject);
begin
 xbinstellen:=true; xoinstellen:=false;
end;

procedure TForm1.ScrollBardScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clScreen);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clScreen);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clScreen);
  if gereset then ScrollPos:=round(d);
  d:=ScrollPos; d:=d/10; EditAll;
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clF);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clG);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clP);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBaraScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clScreen);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clScreen);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clScreen);
  if gereset then ScrollPos:=round(a);
  a:=ScrollPos; a:=a/10; EditAll;
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clF);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clG);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clP);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarbScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clScreen);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clScreen);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clScreen);
  if gereset then ScrollPos:=round(b);
  b:=ScrollPos; b:=b/10; EditAll;
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clF);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clG);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clP);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarcScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clScreen);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clScreen);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clScreen);
  if gereset then ScrollPos:=round(c);
  c:=ScrollPos; c:=c/10; EditAll;
  if Fvastgezet then FunctiePlotten('f',dmin,dmax,clF);
   if Gvastgezet then FunctiePlotten('g',dmin,dmax,clG);
    if Pvastgezet then FunctiePlotten('p',dmin,dmax,clP);
  gereset:=false; ToonFunctievoorschrift;
end;

procedure TForm1.ScrollBarDomeinScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  If Fvastgezet then FunctiePlotten('f',dmin,dmax,clScreen);
  If Gvastgezet then FunctiePlotten('g',dmin,dmax,clScreen);
  If Pvastgezet then FunctiePlotten('p',dmin,dmax,clScreen);
  dint:=ScrollPos; dmin:=-dint div 2; dmax:=-dmin;
  PlotAssenstelsel;
  If Fvastgezet then FunctiePlotten('f',dmin,dmax,clF);
  If Gvastgezet then FunctiePlotten('g',dmin,dmax,clG);
  If Pvastgezet then FunctiePlotten('p',dmin,dmax,clP);
  stoppen:=false;
end;

procedure TForm1.ScrollBarTransparantieScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  AlphaBlendValue:=ScrollPos;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 application.processmessages;
 Plotgebied.Height:=pixy;
 Plotgebied.Width:=pixx;
 Plotgebied.Canvas.Font.Size:=8;
 Plotgebied.Canvas.Pen.Width:=1;
 stoppen:=false; gereset:=false;
 xoinstellen:=false; xbinstellen:=false;
 Fvastgezet:=false;
 Gvastgezet:=false;
 Pvastgezet:=false;
 PlotTangentsOfF:=false;
 PlotTangentsOfP:=false;
 FixTangents:=false;
 dint:=10;
 dmin:=-dint div 2;
 dmax:=-dmin;
 dx:=0.01;
 AlphaBlend:=true;
 AlphaBlendValue:=255;
 d:=0; Uit_d.Text:=conR(d);
 a:=0; Uit_a.Text:=conR(a);
 b:=0; Uit_b.Text:=conR(b);
 c:=0; Uit_c.Text:=conR(c);
 xo:=0.01; Uit_6.Text:=conR(xo);
 xb:=0.01; Uit_7.Text:=conR(xb);
 ToonFunctievoorschriftBouwschema;
 ClearScreen; EditAll;
end;

end.
